{ ############################################################################
       TridenT : TRIDENT_JOB@HOTMAIL.COM     - http://www.trident.fr.st
  ############################################################################ }

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DXDraws, DXClass, DXSprite, DXInput, DXSounds, MPlayer, ExtCtrls, jpeg,
  StdCtrls, ComCtrls{,StdCtrls,ExtCtrls},DIB;

CONST Mvt_Pas : Integer = 2;
      SPRITE_ENGINE_STEP = 8;
// Tableau de valeur pour le mouvement des sprites
CONST Mvt_Tab : ARRAY[1..9] of integer = (0,1,2,3,4,6,8,9,12);

// type de l'Action  mener ...
type {Action : 0=Rien, 1=Random Move; 2=Move location; 3=Follow}
     TNom_Action = (ACTION_NONE, ACTION_RANDOM, ACTION_LOCATION, ACTION_FOLLOW);

     TSprite_Action = RECORD { Nom de l'action } Nom : TNom_Action;
                      { Phase de l'action } Phase,
                      { Direction du dplacament } Valeur,
                      { Dure restante pour l'action } Duree : integer;
                      Go_X,Go_Y : double;
                       END;

type
  TForm1 = class(TDXForm)
    DXDraw1: TDXDraw;
    DXTimer1: TDXTimer;
    DXSpriteEngine1: TDXSpriteEngine;
    DXInput1: TDXInput;
    DXSound1: TDXSound;
    DXWaveList1: TDXWaveList;
    MediaPlayer1: TMediaPlayer;
    Image1: TImage;
    Label_Up: TLabel;
    Label_Right: TLabel;
    Label_Down: TLabel;
    Label_Left: TLabel;
    DXImageList1: TDXImageList;
    DXCurseurList: TDXImageList;
    procedure DXDraw1Initialize(Sender: TObject);
    procedure DXDraw1Finalize(Sender: TObject);
    procedure DXTimer1Timer(Sender: TObject; LagCount: Integer);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
    procedure DXDraw1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure DXDraw1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure DXDraw1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Label_RightMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Label_LeftMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Label_MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Label_UpMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Label_DownMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
   private
    { Dclarations prives }
  public
    { Dclarations publiques }
    procedure Affiche;
  end;

// Dfinition d'un sprite un peu plus sophistiqu, pouvant grer un ennemis.
    TSprite2 = class(TImageSprite)
     En_Mvt : Boolean;
     Obstacle : Boolean;
     Select : Boolean;
     Action : TSprite_Action;
     procedure DoAction;
     procedure DoCollision(Sprite:TSprite; var Done:Boolean);Override;
     procedure DoMove(MoveCount:integer);Override;
     Procedure Move_Sprite(Direction : Integer);
     procedure DoDraw;Override;
    public
     Constructor Create(AParent:TSprite);Override;
    end;

    TWhere_Cursor=(W_DXDraw, W_ToolBar);

var
  Form1: TForm1;
  Mouse_Rect_End_X,Mouse_Rect_End_Y,Mouse_Rect_Start_X,Mouse_Rect_Start_Y : Integer;
  Mouse_X_Abs,Mouse_Y_Abs,Scroll_Engine_X,Scroll_Engine_Y,Mouse_X,Mouse_Y : Integer;
  Mouse_Rect_Trace : Boolean=FALSE;
  Where_Cursor : TWhere_Cursor = W_DXDraw;
  Spr_Select : TSprite;

implementation

{$R *.DFM}

Constructor TSprite2.Create(AParent:TSprite);
BEGIN
     Inherited Create(AParent);
     Z:=2;
     //AnimCount:=Image.PatternCount;
     AnimLooped:=True;
     Animpos:=0;
     AnimStart:=0;
     AnimCount:=5;
     AnimSpeed:=200/1000;
     Visible:=True;
     Collisioned:=True;
     Moved:=True;
     Action.Nom:=ACTION_NONE;
     Action.Duree:=0;
     Action.Valeur:=0;
END;


Procedure TSprite2.DoCollision(Sprite:TSprite; var Done:Boolean);
BEGIN
     If (Sprite is TBackgroundSprite) then
     BEGIN
       Obstacle:=TRUE;
     END;
END;

Procedure TSprite2.Move_Sprite(Direction : Integer);
BEGIN
     En_Mvt:=TRUE;
     case Direction of
     // Pas de mvt
     0:En_Mvt:=FALSE;
     // HAUT
     1: BEGIN
             Y:=Y-Mvt_Pas;
             AnimStart:=0;
        END;
     // DROITE
     2: BEGIN
             X:=X+Mvt_Pas;
             AnimStart:=10;
        END;
     // HAUT + DROITE
     3: BEGIN
             Y:=Y-Mvt_Pas;
             X:=X+Mvt_Pas;
             AnimStart:=5;
        END;
     // BAS
     4: BEGIN
             Y:=Y+Mvt_Pas;
             AnimStart:=20;
        END;
     // BAS + DROITE
     6: BEGIN
             Y:=Y+Mvt_Pas;
             X:=X+Mvt_Pas;
             AnimStart:=15;
        END;
     // GAUCHE
     8: BEGIN
             X:=X-Mvt_Pas;
             AnimStart:=30;
        END;
     // HAUT + GAUCHE
     9: BEGIN
             Y:=Y-Mvt_Pas;
             X:=X-Mvt_Pas;
             AnimStart:=35;
        END;
     // BAS + GAUCHE
     12:BEGIN
             X:=X-Mvt_Pas;
             Y:=Y+Mvt_Pas;
             AnimStart:=25;
        END;
     END;
END;

procedure TSprite2.DoDraw;
begin
     inherited DoDraw;
     if Select then
      Form1.DXCurseurList.Items[1].Draw(Form1.DXDraw1.Surface, round(WorldX), round(WorldY),0);
end;

{Action : 0=Rien, 1=Random Move; 2=Move location; 3=Follow}
Procedure TSprite2.DoAction;
Var dir : Integer;
begin
     Dir:=0;
     case Action.Nom of
      ACTION_NONE:
        if Select then
        With Form1.DXInput1 do
        BEGIN
          //if States=[] then States_vide:=TRUE
           //else States_Vide:=False;
          If IsUp     in States then Inc(Dir,1);
          If IsRight  in States then Inc(Dir,2);
          If IsDown   in States then Inc(Dir,4);
          If IsLeft   in States then Inc(Dir,8);
        Action.Valeur:=Dir;
        END;
      ACTION_RANDOM:;
      ACTION_LOCATION:
       begin
         if ((X=Action.Go_X) AND (Y=Action.Go_Y)) then Action.Nom:=ACTION_NONE;
         if Action.Go_X>X then inc(Dir,2);
         if Action.Go_X<X then inc(Dir,8);
         if Action.Go_Y>Y then inc(Dir,4);
         if Action.Go_Y<Y then inc(Dir,1);
         Action.Valeur:=Dir;
       end;
      ACTION_FOLLOW:;
     end;
end;

Procedure TSprite2.DoMove(MoveCount:integer);
Var Old_X,Old_Y,Save_Y : Double;
BEGIN
     Old_X:=X;
     Old_Y:=Y;
     Obstacle:=FALSE;

     // Rappelle la fonction DoMove de l'ancetre, pour l'animation!!!
     if En_Mvt then inherited DoMove(MoveCount);

     // On continue l'action en cours
     DoAction;
     // dec(Action.Duree);
     // Fin de l'action?
     // if Action.Duree<=0 then Action.Nom:=ACTION_NONE;

     Move_Sprite(Action.Valeur);
     // En cas de collision, on remet les anciennes coordonnes
     if Collision>0 then
     BEGIN
          // Essai juste dX
          Save_Y:=Y;
          Y:=Old_Y;
          if Collision>0 then
          begin
            // Essai juste en dY
            X:=Old_X;
            Y:=Save_Y;
            if Collision>0 then
            begin
              // Mvt impossible, fin de l'action
              Y:=Old_Y;X:=Old_X;
              Action.Nom:=ACTION_NONE;
              Action.valeur:=0;
            end;
          end;
     END;
END;


procedure TForm1.Affiche;
var Spr2 : TSprite2;
BEGIN
     DXSpriteEngine1.Dead;
     //DXDraw1.Surface.Fill(1);
     {Dessin du sprite  sa nouvelle position}
     DXSpriteEngine1.Draw;

     With DXDraw1.Surface.Canvas do
     BEGIN
          //Brush.Style:=bsSolid;
          //Brush.Color:=clRed;

          // Affichage du curseur!
          if Where_Cursor=W_DXDraw then
           DXCurseurList.Items[2].Draw(DXDraw1.Surface
            ,Mouse_X_Abs-(DXCurseurList.Items[2].Height div 2)
            ,Mouse_Y_Abs-(DXCurseurList.Items[2].Width div 2)
            , 0);
          
          // Si Dessine rectangle avec souris alors
          If Mouse_Rect_Trace then
           Rectangle(Mouse_Rect_Start_X,Mouse_Rect_Start_Y,Mouse_X,Mouse_Y);


          Brush.Style:=bsClear;
          Font.Color:=clRed;
          Font.Size:=9;
          TextOut(30,10,' Terres de Lgendes - TRIDENT 1999 - http://www.multimania.com/trident');
          Font.Color:=clWhite;
          TextOut(30,30,DateTimeToStr(Now));
          TextOut(30,50,Format('FPS /max = %4d / %4d',[DXTimer1.FrameRate,1000 div DXTimer1.Interval]));
          Font.Color:=clAqua;

          if (Spr_Select<>nil) AND (Spr_Select is TSprite2) then
          begin
          Spr2:=TSprite2(Spr_Select);
          TextOut(30,80,Format('SELECT : X=%.6d  Y=%.6d  WorldX=%.6d  WorldY=%.6d',
           [round(Spr2.X),round(Spr2.Y),round(Spr2.WorldX),round(Spr2.WorldY)]));
          TextOut(50,100,Format('En Mvt=%.1d  Obstacle=%.1d  AnimLooped=%.1d  '
           +'AnimStart=%.3d  AnimPos=%.3d',[Integer(Spr2.En_Mvt),Integer(Spr2.Obstacle),
           Integer(Spr2.AnimLooped),Integer(Spr2.AnimStart),ROund(Spr2.AnimPos)]));
          TextOut(50,120,Format('Action : Nom=%.2d Valeur=%.2d Dure=%.8d',[Integer(Spr2.Action.Nom)
           ,Integer(Spr2.Action.Valeur),Spr2.Action.Duree]));
          end;
          TextOut(30,140,Format('Mouse move: Mouse_X=%.4d  Mouse_Y=%.4d  START:  X=%.4d  Y=%.4d  END: X=%.4d  Y=%.4d'
           ,[Mouse_X,Mouse_Y,Mouse_Rect_Start_X,Mouse_Rect_Start_Y,Mouse_Rect_End_X,Mouse_Rect_End_Y]));
          TextOut(50,160,Format('Mouse_Abs_X=%.4d  Mouse_Abs_Y=%.4d',[Mouse_X_Abs,Mouse_Y_Abs]));
          TextOut(30,200,Format('DXSpriteEngine : Count=%.2d  AllCount=%.2d  DrawCount=%.2d'
           ,[DXSpriteEngine1.Engine.Count,DXSpriteEngine1.Engine.AllCount,DXSpriteEngine1.Engine.DrawCount]));

          Release;
     END;

     {flip}
     DXdraw1.flip;
END;

procedure TForm1.DXDraw1Initialize(Sender: TObject);
begin
     DXDraw1.Cursor:=CrNone;
     DXTimer1.Enabled:=True;
end;

procedure TForm1.DXDraw1Finalize(Sender: TObject);
begin
     DXTimer1.Enabled:=False;
end;

procedure TForm1.DXTimer1Timer(Sender: TObject; LagCount: Integer);
begin
     if not DXDraw1.CanDraw then exit;
     DXInput1.Update;

     DXSpriteEngine1.Engine.X:=Form1.DXSpriteEngine1.Engine.X+Scroll_Engine_X;
     DXSpriteEngine1.Engine.Y:=Form1.DXSpriteEngine1.Engine.Y+Scroll_Engine_Y;

     DXSpriteEngine1.Move(1);
     Affiche;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
     If key=VK_ESCAPE then Close;

     // Traitement des sons
     if key=VK_F6 then DXWaveList1.Items.Find('Arghh').Play(False);
     if key=VK_F3 then DXWaveList1.Items.Find('My_Lord').Play(False);
     if key=VK_F4 then DXWaveList1.Items.Find('Your_Eminence').Play(False);
     if key=VK_F5 then DXWaveList1.Items.Find('Your_orders').Play(False);

     if key=VK_F12 then
      if MediaPlayer1.Mode=mpPlaying then MediaPlayer1.Pause
       else MediaPlayer1.Play;

     if key=ord('A') then DXTimer1.interval:=DXTimer1.interval+1;
     if key=ord('Z') then DXTimer1.interval:=DXTimer1.interval-1;
     //if key=ord('W') then Player1.Engine.X:=Player1.Engine.X-4;

end;

Procedure TForm1.FormCreate(Sender: TObject);
Var i:integer;
begin
     Randomize;
     MediaPlayer1.Play;
     DXSound1.Initialize;
     DXImageList1.Items.LoadFromFile('Anim.DXG');
     DXCurseurList.Items.LoadFromFile('Curseurs.DXG');
     //DXDraw1.ColorTable:=DXImageList1.Items.ColorTable;
     //DXDraw1.DefColorTable:=DXImageList1.Items.ColorTable;
     //DXDraw1.UpdatePalette;

     DXWAveList1.Items.LoadFromFile('SND1.dxw');

     Scroll_Engine_X:=0;
     Scroll_Engine_Y:=0;

     with TBackgroundSprite.Create(DXSpriteEngine1.Engine) do
     BEGIN
          SetMapSize(2,2);
          Image:=DXImageList1.Items.Find('Muret');
          X:=300;
          Y:=20;
          Z:=0;
          Tile:=False;
          Collisioned:=True;
     END;

     With TBackgroundSprite.Create(DXSpriteEngine1.Engine) do
     BEGIN
          SetMapSize(4,8);
          Image:=DXImageList1.Items.Find('gallet');
          Z:=0;
          x:=20;y:=20;
     END;

     With TBackgroundSprite.Create(DXSpriteEngine1.Engine) do
     BEGIN
          SetMapSize(1,1);
          Image:=DXImageList1.Items.Find('herbe');
          Z:=0;
          Tile:=True;
     END;

     // init des personnages
     For i:=1 to 5 do
     BEGIN
          With TSprite2.Create(DXSpriteEngine1.Engine) do
          BEGIN
               X:=350+(i mod 2)*80;
               Y:=250+(i div 2)*80;
               if i=1 then Image:=Form1.DXImageList1.Items.Find('Archer2')
                else Image:=Form1.DXImageList1.Items.Find('Grunt2');
               //Width:=Image.Width;
               //Height:=Image.Height;
          END;
     END;

end;


Function Select_Sprite_XY : Integer;
var Spr_Tmp : TSprite;
    i : integer;
BEGIN
     // Effacement des selections prcedentes!
     for i:=0 to Form1.DXSpriteEngine1.Engine.Count-1 do
     begin
          Spr_Tmp:=Form1.DXSpriteEngine1.Engine.Items[i];
          if (Spr_Tmp is TSprite2) then
           TSprite2(Spr_Tmp).Select:=FALSE;
     end;

     Spr_Tmp:=(Form1.DXSpriteEngine1.Engine.GetSpriteAt(Mouse_X_Abs+1,Mouse_Y_Abs+1));//ImageSprite);
     if (Spr_Tmp is TSprite2) and (Spr_Tmp<>nil) then
      TSprite2(Spr_Tmp).Select:=TRUE;

      Result:=Integer(Spr_Tmp<>nil);
END;

procedure TForm1.DXDraw1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
     Mouse_X_Abs:=X;
     Mouse_Y_Abs:=Y;
     Where_Cursor:=W_DXDraw;
     Mouse_X:=X-round(DXSpriteEngine1.Engine.X);
     Mouse_Y:=Y-round(DXSpriteEngine1.Engine.Y);
end;

procedure TForm1.DXDraw1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
     Mouse_Rect_Start_X:=X;
     Mouse_Rect_Start_Y:=Y;
     //Mouse_Rect_Trace:=TRUE;
end;

procedure TForm1.DXDraw1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var Spr : TSprite2;
begin

     { Clic bouton gauche pour slctionner }
     if Button=mbLeft then
     begin
     Mouse_Rect_End_X:=X;
     Mouse_Rect_End_Y:=Y;
     Mouse_Rect_Trace:=FALSE;
     Select_Sprite_XY;
     Spr_Select:=(Form1.DXSpriteEngine1.Engine.GetSpriteAt(Mouse_X_Abs+1,Mouse_Y_Abs+1));
     end;

     { Bouton gauche pour dplacer }
     if Button=mbRight then
      if Spr_Select is TSprite2 then
       if Spr_Select<>nil then
     begin
     Spr:=TSprite2(Spr_Select);
     // Determination d'une new action;
     Spr.Action.Nom:=ACTION_LOCATION;
     Spr.Action.Valeur:=0;
     //Spr.Action.Go_X:=((Mouse_X - Spr.Width div 2) AND $7FFFFFFE);
     Spr.Action.Go_X:=((Mouse_X - Spr.Width div 2) div 2)*2;
     Spr.Action.Go_Y:=((Mouse_Y - Spr.Height div 2) div 2)*2;
     // Spr_Select.Action.Duree:=round(random(300)+10);
     end;
end;

procedure TForm1.Label_RightMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
     Scroll_Engine_X:=-SPRITE_ENGINE_STEP;
end;

procedure TForm1.Label_LeftMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
     Scroll_Engine_X:=SPRITE_ENGINE_STEP;
end;

procedure TForm1.Label_MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
     Scroll_Engine_X:=0;
     Scroll_Engine_Y:=0;
end;

procedure TForm1.Label_UpMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
     Scroll_Engine_Y:=SPRITE_ENGINE_STEP;
end;

procedure TForm1.Label_DownMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
     Scroll_Engine_Y:=-SPRITE_ENGINE_STEP;
end;

procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
     Where_Cursor:=W_ToolBar;
end;

end.
